#version 330 core
layout(location = 0) in vec3 vertexPos;

out vec2 UV;
out vec4 aPos;

uniform mat4 MVP;

uniform vec3 wPos;
uniform vec3 wRad;

uniform float waterlevel;



void main(){
	vec3 pos = vertexPos;

	//aPos = vec4(pos,1.0);

	float xmin=wPos.x-wRad.x;
	float xmax=wPos.x+wRad.x;
	float zmin=wPos.z-wRad.z;
	float zmax=wPos.z+wRad.z;
	UV = vec2( (pos.x-xmin)/(xmax-xmin), (pos.z-zmin)/(zmax-zmin) );

	// NOTE:  it's pretty good even without varying the surface pos
	pos.y = waterlevel;

	aPos = vec4(pos,1.0);
	gl_Position =  MVP * vec4(pos,1.0);
}


//--
//-- Copyright (C) 2019  <fastrgv@gmail.com>
//--
//-- This program is free software: you can redistribute it and/or modify
//-- it under the terms of the GNU General Public License as published by
//-- the Free Software Foundation, either version 3 of the License, or
//-- (at your option) any later version.
//--
//-- This program is distributed in the hope that it will be useful,
//-- but WITHOUT ANY WARRANTY; without even the implied warranty of
//-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//-- GNU General Public License for more details.
//--
//-- You may read the full text of the GNU General Public License
//-- at <http://www.gnu.org/licenses/>.
//--

